<!DOCTYPE HTML>
<html>
<head>
<link rel="stylesheet" type="text/css" href="./css/font.css" />
</head>
<body>

<?php
ini_set('display_errors', 'On');
error_reporting(E_ALL);

if(!isset($_SESSION['uid']))
{
    ?>
    not logged in<br />
    <?php
    //echo $footer;
    exit;
}
if((!isset($_GET["x"])) or (!isset($_GET["y"])))
{
    ?>
    destination missing<br />
    <?php
    //echo $footer;
    exit;
}
$uid = $_SESSION['uid'];
$x = $_GET["x"];
$y = $_GET["y"];

$nmap = loadfromfile("./map/default.txt");

$path = pathfind(1,1,$x,$y,$nmap);
foreach($path as $coord)
{
    $x = $coord[1];
    $y = $coord[2];
    $nmap[$y][$x] = "~";
}
show($nmap);


function loadfromfile($filename)
{
    $nmap = array();
    $file = fopen($filename,"r");
    while(! feof ($file))
    {

        $nmap[] = str_split(fgets($file));
        
    }
    //print_r($nmap);
    fclose($file);
    return $nmap;
}

function show($nmap)
{
    //echo "<table border=0 cellspacing=0 cellpadding=0 frame=void>";
    echo "<table>";
    foreach($nmap as $line)
    {
        echo "<tr>";
        foreach($line as $char)
        {
            echo "<th>".$char."</th>";
        }
        echo "</tr>";
    }
    echo "</table>";
}

//array(f, x, y, g, h)
//where
//h = heuristic
//f = sum
//g = cost from start

function heuristic($ax, $ay ,$bx, $by)
{
    return abs($ax-$bx) . abs($ay-$by);
}

function neighbor($x, $y)
{
    $tmp = array();
    $tmp[] = array($x+1,$y);
    $tmp[] = array($x,$y+1);
    $tmp[] = array($x,$y-1);
    $tmp[] = array($x-1,$y);
    return $tmp;
}

function make_node($x,$y,$nmap)
{
    $cost = 1;
    if($nmap[$y][$x]=='.')
    {
        return array(0,$x,$y,$cost,0,0);
    }
}

function pathfind($ax, $ay ,$bx, $by, $map)
{
    $close = array();
    $from = 0;
    $h = heuristic($ax, $ay ,$bx, $by);
    $open = array(array($h,$ax,$ay,0,$h,$from));

    while(!empty($open))
    {
        //=====================get the lowest from $open, move to closed
        //heapfy
        for($i=1;$i<sizeof($open);$i++)
        {
            $c = $i;
            while($c>0)
            {
                $p = ($c-1)/2;      //parent
                $cc = (sizeof($open)-$c)-1;
                $pp = (sizeof($open)-$p)-1;
                if($open[$cc][0] < $open[$pp][0])
                {
                    //swap
                    $tmp = $open[$pp];
                    $open[$pp] = $open[$cc];
                    $open[$cc] = $tmp;
                }
                $c = $p;
            }
        }
        //heapfy
        $lowest = array_pop($open);
        $close[] = $lowest;
        //=================================if goal acheived then reconstruct
        if($lowest[1] == $bx and $lowest[2] == $by)
        {
                $ri = sizeof($close)-1;
                $ra = array();
                while($ri>0)
                {
                    $ra[] = $close[$ri];
                    $ri = $close[$ri][5];
                }
                return $ra;
        }
        //=================================find all neighbor
        foreach(neighbor($lowest[1], $lowest[2]) as $tmp)
        {
            $x = $tmp[0];
            $y = $tmp[1];
            $new = make_node($x,$y,$map);
            //==================================if in closed
            if((find($x,$y,$close)==NULL) and ($new!=NULL))
            {
                $new[3] = $new[3] + $lowest[3];
                $new[4] = heuristic($x, $y, $bx, $by);
                $new[0] = $new[3] + $new[4];
                $new[5] = $from;
                //================================if not in open
                $pmt = find($x,$y,$open);
                if($pmt == NULL)
                {
                    $open[] = $new;
                }
                elseif($new[3] < $open[$pmt][3])
                {
                    $open[$pmt] = $new;
                }
            }
        }
        $from = $from + 1;
    }
    return ;
}

function find($x,$y,$set)
{
    for($i=0;$i<sizeof($set);$i++)
    {
        if($set[$i][1]==$x and $set[$i][2]==$y)
        {
            return $i;
        }
    }
    return NULL;
}

?>

</body>
</html>
